Imports mVCI_CAN_DotNET

Public Class Form1
    Public Const MODNUM As Integer = 2
    Dim ComPort(MODNUM - 1) As Byte
    Dim I7565H1H2_Mod(MODNUM - 1) As MVCI_SDK
    Dim i As Integer


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbo_ComPort.SelectedIndex = 0
        cbo2_ComPort.SelectedIndex = 0
        cbo_DevType.SelectedIndex = 0
        cbo2_DevType.SelectedIndex = 0
        cbo_C1Baud.SelectedIndex = 14
        cbo_C2Baud.SelectedIndex = 14
        cbo_CANNo.SelectedIndex = 0

        'cbo_CANNo.Enabled = False
        btn_SendCANMsg.Enabled = False
        btn_RecvCANMsg.Enabled = False
        btn_EnHWCycTxMsg.Enabled = False
        btn_DisHWCycTxMsg.Enabled = False
        btn_CANStatus.Enabled = False
        btn_ClrErrLED.Enabled = False
        btn_ModInfo.Enabled = False
        btn_RstMod.Enabled = False

        Show_CmdStatus("Open CANPort First !!")

        For i = 0 To (MODNUM - 1)
            I7565H1H2_Mod(i) = New MVCI_SDK()
            I7565H1H2_Mod(i).InitDLL()
        Next

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        lbl_TimeStr.Text = "DateTime : " + System.DateTime.Now.ToString()
    End Sub

    Private Sub cbo_DevType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbo_DevType.SelectedIndexChanged
        If cbo_DevType.SelectedIndex = 0 Then
            cbo_C2Baud.Enabled = False
        Else
            cbo_C2Baud.Enabled = True
        End If
    End Sub

    Private Sub btn_OpenCAN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_OpenCAN.Click
        Dim Ret As Integer
        Dim Mod_CfgData(255) As Byte

        'Listen Only Mode
        Mod_CfgData(0) = 0                      'CAN1 => 0:Disable, 1:Enable
        Mod_CfgData(1) = 0                      'CAN2 => 0:Disable, 1:Enable
        I7565H1H2_Mod(0).mVCI_Set_MOD_Ex(Mod_CfgData)

        ComPort(0) = (cbo_ComPort.SelectedIndex + 1)
        Ret = I7565H1H2_Mod(0).mVCI_OpenCAN_NoStruct(ComPort(0), (cbo_DevType.SelectedIndex + 1), _
                                            (Convert.ToSingle(cbo_C1Baud.Text) * 1000), _
                                            (Convert.ToSingle(cbo_C2Baud.Text) * 1000))
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("Mod1_OpenCAN Success")
            PortOpen_BtnFunc()
        End If

        ComPort(1) = (cbo2_ComPort.SelectedIndex + 1)
        Ret = I7565H1H2_Mod(1).mVCI_OpenCAN_NoStruct(ComPort(1), (cbo2_DevType.SelectedIndex + 1), _
                                            (Convert.ToSingle(cbo_C1Baud.Text) * 1000), _
                                            (Convert.ToSingle(cbo_C2Baud.Text) * 1000))
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("Mod2_OpenCAN Success")
            PortOpen_BtnFunc()
        End If

    End Sub


    Private Sub btn_CloseCAN_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_CloseCAN.Click
        Dim Ret As Integer

        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_CloseCAN(ComPort(i))
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                Show_CmdStatus("Mod" & (i + 1) & "_CloseCAN" & (i + 1) & " Success")
                PortClose_BtnFunc()
            End If
        Next

    End Sub

    Private Sub btn_CANStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_CANStatus.Click
        Dim Ret As Integer
        Dim CAN_No As Byte
        Dim CurCANBaud As Long
        Dim CANReg As Byte, CANTxErrCnt As Byte, CANRxErrCnt As Byte, ModState As Byte

        CurCANBaud = CANReg = CANTxErrCnt = CANRxErrCnt = ModState = 0
        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_Get_CANStatus_NoStruct(CAN_No, CurCANBaud, CANReg, CANTxErrCnt, CANRxErrCnt, ModState)
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                MessageBox.Show("[Mod" & (i + 1) & "]\n" & _
                                "[CAN" & CAN_No & "_Status]" & vbNewLine & _
                                "Baudrate: " & String.Format("{0:0000.000}", CurCANBaud / 1000) & " (Kbps)" & vbNewLine & _
                                "Register: " & String.Format("0x{0:X2}", CANReg) & vbNewLine & _
                                "TxErrCnt: " & String.Format("0x{0:X2}", CANTxErrCnt) & vbNewLine & _
                                "RxErrCnt: " & String.Format("0x{0:X2}", CANRxErrCnt) & vbNewLine & _
                                "ModState: " & String.Format("0x{0:X2}", ModState))
            End If
        Next

    End Sub

    Private Sub btn_ClrErrLED_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ClrErrLED.Click
        Dim Ret As Integer
        Dim CAN_No As Byte

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_Clr_BufOverflowLED(CAN_No)
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                MessageBox.Show("Mod" & (i + 1) & "_Clear CAN" & CAN_No & "ErrLED OK")
            End If
        Next

    End Sub

    Private Sub btn_ModInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ModInfo.Click
        Dim ModID(11) As Char
        Dim FWVer(11) As Char
        Dim HWSN(15) As Char
        Dim Ret As Integer

        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_Get_MODInfo_NoStruct(ModID, FWVer, HWSN)
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                MessageBox.Show("Module" & (i + 1))
                MessageBox.Show("ModName= " & New String(ModID))
                MessageBox.Show("FW_Ver= " & New String(FWVer))
                MessageBox.Show("HW_SN= " + New String(HWSN))
            End If
        Next

    End Sub

    Private Sub btn_RstMod_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RstMod.Click
        Dim Ret As Integer

        Show_CmdStatus("Waiting for Reset Module OK ...")
        For i = 0 To (MODNUM - 1)
            I7565H1H2_Mod(i).mVCI_DoEvents()
            Ret = I7565H1H2_Mod(i).mVCI_Rst_MOD()
            If Ret = 10 Then
                I7565H1H2_Mod(i).mVCI_CloseCAN(ComPort(i))
                PortClose_BtnFunc()
                MessageBox.Show("Mod" & (i + 1) & "_Module Reset OK")
            Else
                ShowErrMsg(Ret)
            End If
        Next

    End Sub

    Private Sub btn_SendCANMsg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SendCANMsg.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, Mode As Byte, RTR As Byte, DLC As Byte
        Dim Data(8) As Byte
        Dim CANID As Long

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Mode = 0
        RTR = 0
        DLC = 8
        CANID = &H100
        Data(0) = &H12
        Data(1) = &H34
        Data(2) = &H56
        Data(3) = &H78
        Data(4) = &H90
        Data(5) = &HAB
        Data(6) = &HCD
        Data(7) = &HEF

        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_SendCANMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID + i, Data)
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                Show_CmdStatus("Mod" & (i + 1) & "_Send CAN" + CAN_No.ToString() + "_Msg OK")
            End If
        Next

    End Sub

    Private Sub btn_RecvCANMsg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RecvCANMsg.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, Mode As Byte, RTR As Byte, DLC As Byte
        Dim Data(8) As Byte
        Dim CANID As Long, TH As Long, TL As Long
        Dim DL As String, DH As String

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Mode = RTR = DLC = 0
        CANID = TH = TL = 0

        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_RecvCANMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID, TL, TH, Data)
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                DL = Strings.Right("00" & Hex(Data(3)), 2) & Strings.Right("00" & Hex(Data(2)), 2) & _
                    Strings.Right("00" & Hex(Data(1)), 2) & Strings.Right("00" & Hex(Data(0)), 2)
                DH = Strings.Right("00" & Hex(Data(7)), 2) & Strings.Right("00" & Hex(Data(6)), 2) & _
                    Strings.Right("00" & Hex(Data(5)), 2) & Strings.Right("00" & Hex(Data(4)), 2)
                MessageBox.Show("[Mod" & (i + 1) & "]\n" & _
                                "Mode   => " & Mode & vbNewLine & _
                                "RTR    => " & RTR & vbNewLine & _
                                "DLC    => " & DLC & vbNewLine & _
                                "CANID  => 0x" & CANID.ToString("X") & vbNewLine & _
                                "Data_L => 0x" & DL & vbNewLine & _
                                "Data_H => 0x" & DH & vbNewLine & _
                                "Msg_Time => " & String.Format("{0:0.0000}", (CSng(TH * 4294967296.0# + TL) / 10000)) & " (sec)")
            End If
        Next

    End Sub

    Private Sub btn_EnHWCycTxMsg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_EnHWCycTxMsg.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, Mode As Byte, RTR As Byte, DLC As Byte
        Dim Data(8) As Byte
        Dim CANID As Long

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        Mode = 0
        RTR = 0
        DLC = 8
        CANID = &H335
        Data(0) = &H12
        Data(1) = &H34
        Data(2) = &H56
        Data(3) = &H78
        Data(4) = &H90
        Data(5) = &HAB
        Data(6) = &HCD
        Data(7) = &HEF

        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_EnableHWCyclicTxMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID + i, Data, 10, 200)                '//Send 200 CANMsg with 10ms period and Stop
            'Ret = I7565H1H2_Mod(i).mVCI_EnableHWCyclicTxMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID, Data, TPFLOATMS(0.5), 200)    '//Send 200 CANMsg with 0.5ms period and Stop
            'Ret = I7565H1H2_Mod(i).mVCI_EnableHWCyclicTxMsg_NoStruct(CAN_No, Mode, RTR, DLC, CANID, Data, TPFLOATMS(2.5), 200)    '//Send 200 CANMsg with 2.5ms period and Stop
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                Show_CmdStatus("Mod" & (i + 1) & "_HWCyclic SendCAN" & CAN_No & "Msg Start")
            End If
        Next

    End Sub

    Private Sub btn_DisHWCycTxMsg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_DisHWCycTxMsg.Click
        Dim Ret As Integer
        Dim CAN_No As Byte

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_DisableHWCyclicTxMsg()
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                Show_CmdStatus("Mod" & (i + 1) & "_HWCyclic SendCAN" & CAN_No & "Msg Stop")
            End If
        Next

    End Sub

    Private Sub btn_RxMsgCnt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RxMsgCnt.Click
        Dim Ret As Integer
        Dim CAN_No As Byte
        Dim RxMsgCnt As Long

        RxMsgCnt = 0
        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_Get_RxMsgCnt(CAN_No, RxMsgCnt)
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                MessageBox.Show("Mod" & (i + 1) & "_CAN" & CAN_No & "RxMsgCnt= " & RxMsgCnt)
            End If
        Next

    End Sub

    Private Sub btn_RxMsgBufIsFull_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_RxMsgBufIsFull.Click
        Dim Ret As Integer
        Dim CAN_No As Byte, RxSoftBufFull_Flag As Byte

        RxSoftBufFull_Flag = 0
        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_Get_RxMsgBufIsFull(CAN_No, RxSoftBufFull_Flag)
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                MessageBox.Show("Mod" & (i + 1) & "_CAN" & CAN_No & "RxMsgBuf FullFlag= " & RxSoftBufFull_Flag)
            End If
        Next

    End Sub

    Private Sub btn_ClrRxMsgBuf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ClrRxMsgBuf.Click
        Dim Ret As Integer
        Dim CAN_No As Byte

        CAN_No = (cbo_CANNo.SelectedIndex + 1)
        For i = 0 To (MODNUM - 1)
            Ret = I7565H1H2_Mod(i).mVCI_Clr_RxMsgBuf(CAN_No)
            If Ret <> 0 Then
                ShowErrMsg(Ret)
            Else
                MessageBox.Show("Mod" & (i + 1) & "_Clear CAN" & CAN_No & " RxSoftBuf OK")
            End If
        Next

    End Sub

    Private Sub btn_DllVer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_DllVer.Click
        Dim DllVer As Long

        DllVer = I7565H1H2_Mod(0).mVCI_Get_DllVer()
        MessageBox.Show("VCI_DllVer= v" & ((DllVer >> 8) And &HFF) & "." & String.Format("{0:00}", (DllVer And &HFF)))
    End Sub

    Private Sub btn_Set_UserDefISR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Set_UserDefISR.Click
        Dim Ret As Integer

        UserDefISR.MyTest0_Val = 0
        UserDefISR.MyTest1_Val = 0

        pMyTestISR0 = New MVCI_SDK.PFN_UserDefISR(AddressOf MyTestISR0)
        pMyTestISR1 = New MVCI_SDK.PFN_UserDefISR(AddressOf MyTestISR1)

        'Enable UserDefISR Function
        'The UserDefISR (pMyTestISR0) will be trigged when receiving any one CANMsg
        Ret = I7565H1H2_Mod(0).mVCI_Set_UserDefISR(MVCI_SDK.ISRNO_0, MVCI_SDK.ISR_CANPORT_ALL, MVCI_SDK.ISR_CANMODE_ALL, MVCI_SDK.ISR_CANID_ALL, pMyTestISR0)

        'The UserDefISR (pMyTestISR1) will be trigged when only receiving CANMsg with CANID=0x100
        Ret = I7565H1H2_Mod(1).mVCI_Set_UserDefISR(MVCI_SDK.ISRNO_1, MVCI_SDK.CAN1, MVCI_SDK.MODE_11BIT, &H100, pMyTestISR1)
        If Ret <> 0 Then
            ShowErrMsg(Ret)
        Else
            Show_CmdStatus("Set_UserDefISR OK")
        End If
    End Sub

    Private Sub btn_Clr_UserDefISR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Clr_UserDefISR.Click
        'Disable UserDefISR Function */
        I7565H1H2_Mod(0).mVCI_Clr_UserDefISR(MVCI_SDK.ISRNO_0)
        I7565H1H2_Mod(1).mVCI_Clr_UserDefISR(MVCI_SDK.ISRNO_1)

        MessageBox.Show("ISR0_Val=" & MyTest0_Val & ", ISR1_Val=" & MyTest1_Val)
    End Sub

    Private Sub btn_Get_ISRCANData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Get_ISRCANData.Click
        Dim ISR1_CANDataLen As Byte
        Dim ISR1_CANData(8) As Byte

        I7565H1H2_Mod(1).mVCI_Get_ISRCANData(MVCI_SDK.ISRNO_1, ISR1_CANDataLen, ISR1_CANData)
        MessageBox.Show("ISR1_Data(" & ISR1_CANDataLen & ") = " & Hex(ISR1_CANData(0)) & "_" & Hex(ISR1_CANData(1)) & "_" & Hex(ISR1_CANData(2)) & "_" & Hex(ISR1_CANData(3)) & "_" & _
                         Hex(ISR1_CANData(4)) & "_" & Hex(ISR1_CANData(5)) & "_" & Hex(ISR1_CANData(6)) & "_" & Hex(ISR1_CANData(7)))


    End Sub
End Class
